
function mxl_showErrorByResponseText(responseText, baseMsg){
  var validate = Ext.util.JSON.decode(responseText).validate;
  var error = Ext.util.JSON.decode(responseText).error;
  if (validate){
    Ext.Msg.alert("Ошибка", baseMsg + "<br><br>Ошибка при валидации:<br>"+ validate);
  } else if (error){
    Ext.Msg.alert("Ошибка", baseMsg + "<br><br>Ошибка:<br>" + error);
  } else {
    Ext.Msg.alert("Ошибка", baseMsg);
  }
}

var mxl_wgs_time_shift = 0;
var mxl_wgs_server_time_zone = '-5';

var store_dbg_refcity1;
var dbg_refcity1;

function on_refcity_specialkey(f, e) {
  if (e.getKey() == Ext.EventObject.ENTER) {
    e.keyCode = Ext.EventObject.TAB;
    dbg_gbg28.fireEvent("keypress", e);
  }
}
var edit_refcity_city_id = new Ext.form.NumberField({
  decimalPrecision: 0,
  listeners:{specialkey:on_refcity_specialkey}
});
var edit_refcity_city_name = new Ext.form.TextField({maxLength:250, listeners:{specialkey:on_refcity_specialkey}});


var record_refcity1= Ext.data.Record.create([
  {name:"city_id, type:int"},
  {name:"city_name, type:string"}
   ]);

function mxl_onbeforeunload(){
  var err_str = "";
  if (store_dbg_refcity1.getModifiedRecords().length > 0){
    var not_saved_rows = store_dbg_refcity1.getModifiedRecords().length;
    err_str += "    \"Справочник: Города\" - " + not_saved_rows + 
      (not_saved_rows == 1 ? " строка" : " строк");
  }
  if (err_str)
    return "Вы не сохранили изменения в: \n " + 
      err_str + " \n Вы уверены, что хотите уйти со страницы?\n";
};

function startAutoGenScript(){
store_dbg_refcity1 = new Ext.data.Store({
  reader: new Ext.data.JsonReader({
  id:"store_dbg_refcity1",
  root: "rows"
  },
  [
  {name: "city_id",  type: "int", mapping:"city_id"},
  {name: "city_name",  type: "string", mapping:"city_name"}
  ]),
  pruneModifiedRecords: true,  proxy: new Ext.data.HttpProxy({
  url: "src/widget/request/getdbgrid.php",
  method: "POST"
  }),
  baseParams:{gridName: "refcity", pkey: "city_id", sid:""},
  listeners: {update : strgOnUpdate_store_dbg_refcity1}
  });

dbg_refcity1 = new Ext.grid.EditorGridPanel({  title: "Справочник: Города" +
"<span id='dbg_refcity1_notsavedrows'></span>",
  store: store_dbg_refcity1,
  applyTo: "dbg_refcity1",
  loadMask: true,  sm: new Ext.grid.RowSelectionModel({ singleSelect: true   }),
  frame: true,
  height:300,
  width:300,
  autoEncode: true, 
  listeners: {afteredit : grdOnAfterEdit_dbg_refcity1},
  tools:[{id:"refresh", qtip: "Обновить данные", handler: dbgRefreshData_refcity1, scope:dbg_refcity1},
         {id:"plus",    qtip: "Добавить строку", handler: dbgAppendRow_refcity1, scope:dbg_refcity1},
         {id:"minus",   qtip: "Удалить строку", handler: dbgDeleteRow_refcity1, scope:dbg_refcity1 },
         {id:"save",    qtip: "Сохранить данные", handler: dbgSaveRow_refcity1, scope:dbg_refcity1 }
   ],
  clicksToEdit: 1,
  columns: [
   {header: "Код города", dataIndex: "city_id", width: 60, align: "right" , readOnly: true, hidden: true, sortable: true},
   {header: "Город", dataIndex: "city_name", width: 180, editor: edit_refcity_city_name, sortable: true}
  ]
  });

function dbgGridUpdateInf_dbg_refcity1(grid){
  var el = Ext.get("dbg_refcity1_notsavedrows").dom;
  var nsr_str = "";
  var notSavedRows = grid.getStore().getModifiedRecords().length;
  if (notSavedRows > 0){
    nsr_str = "  &nbsp&nbsp[Не сохраненные строки: <font color=red>" 
      + notSavedRows + "</font>] ";
  }
  if (el)
    el.innerHTML = nsr_str;
};


store_dbg_refcity1.allready_first_load = false;
mxl_check_and_load_grid_store(store_dbg_refcity1,false);

function dbgAppendRow_refcity1(event, toolEl, panel) {
  var newRecord = new record_refcity1({});
  var sel = panel.getSelectionModel().getSelected();
  var selIndex = 1;
  if (sel) 
    selIndex += panel.getStore().indexOf(sel)
  else 
    selIndex = panel.getStore().getCount();
  panel.getStore().insert(selIndex, newRecord);
  panel.getSelectionModel().selectRow(selIndex);
  panel.getView().focusRow(selIndex);
}

function grdOnAfterEdit_dbg_refcity1(e){
  var rec = e.record;
};
function strgOnUpdate_store_dbg_refcity1(e){
  dbgGridUpdateInf_dbg_refcity1(dbg_refcity1);
};
function dbgDeleteRow_refcity1(event, toolEl, panel){
 var sm = panel.getSelectionModel();
 var sel = sm.getSelected();
 if (sm.hasSelection()){
    Ext.Msg.show({
    title: "Удаление строки",
    buttons: Ext.MessageBox.YESNO,
    msg:"Вы уверены что хотите удалить выбранные строки из \"" + panel.title + "\"?", 
    fn: function(btn){
         if (btn == "yes"){
          if (sel.get(panel.store.baseParams["pkey"]) > 0)  {
             var conn = new Ext.data.Connection();
             conn.request({
             url: "src/widget/request/getdbgrid.php",
             params: {
             action: "delete",
             gridName: panel.getStore().baseParams["gridName"],
             params: panel.getStore().baseParams["params"],
             key: sel.get(panel.getStore().baseParams["pkey"])
            ,sid:""
               },
             success: function(resp,opt) {
               var fail = Ext.util.JSON.decode(resp.responseText).failure;
               if (fail) {
                 mxl_showErrorByResponseText(resp.responseText, "Не удалось удалить строку");
                } else {

                 panel.getStore().remove(sel);
                 dbgGridUpdateInf_dbg_refcity1(dbg_refcity1);
               }
              },
             failure: function(resp,opt) {
               Ext.Msg.alert("Ошибка", "Не удалось удалить строку");
              }
             });
            } else {
               panel.getStore().remove(sel);
               dbgGridUpdateInf_dbg_refcity1(dbg_refcity1);
            }
          }
        }
    })
 } else {
     Ext.MessageBox.alert("Сообщение", "Не выбрана строка." )
 };
};
function dbgRefreshData_refcity1(event, toolEl, panel){
  panel.getStore().rejectChanges();
  panel.getStore().reload();
  strgOnUpdate_store_dbg_refcity1(panel.getStore());
};
function dbgSaveRow_refcity1(event, toolEl, panel) {
  var sm = panel.getSelectionModel();
  var modRec = sm.grid.store.getModifiedRecords();
  if (modRec.length < 1)
	  return;

  var pKey = panel.getStore().baseParams["pkey"];
  var keys       = new Array();
  var recordIds  = new Array();
  var rowsTS = new Array();
  for ( var i = 0; i < modRec.length; i++) {
    var curRec   = modRec[i];

    rowsTS[i]    = curRec.data;
    recordIds[i] = curRec.id;
    key1 = curRec.get(pKey);
    keys[i]      = (key1 ? key1 : "");
  }
  var keysData   = Ext.encode(keys);
  var rowsTSData = Ext.encode(rowsTS);

  var conn = new Ext.data.Connection();  conn.request({    url: "src/widget/request/getdbgrid.php",
    params: {
      action: "saverows",
      gridName: panel.getStore().baseParams["gridName"],
      params: panel.getStore().baseParams["params"],
      keys: keysData,
      rowsData: rowsTSData
      ,sid:""
    },
    success: function(resp,opt) {
      var fail = Ext.util.JSON.decode(resp.responseText).failure;
      if (fail) {
        mxl_showErrorByResponseText(resp.responseText, "Не удалось сохранить данные");
      } else {

        var row_is_saved = Ext.util.JSON.decode(resp.responseText).row_is_saved;
        var insert_ids   = Ext.util.JSON.decode(resp.responseText).insert_ids;
        for(var i = 0; i < row_is_saved.length; i++){
        	if (row_is_saved[i]){
        		var insert_id = insert_ids[i];
        		var recordToCh = sm.grid.store.getById(recordIds[i]);
        		if (insert_id > 0)
        			recordToCh.set(pKey, insert_id);
        		recordToCh.commit();
        	}else
        		Ext.Msg.alert("Ошибка", "Не удалось сохранить данные");
        }
      }
    },
    failure: function(resp,opt) {
      Ext.Msg.alert("Ошибка", "Не удалось сохранить данные");
    }
  });
}



var root = window.addEventListener || window.attachEvent ?
    window : 
    document.addEventListener ? document : null;
root.onbeforeunload = mxl_onbeforeunload;

Ext.QuickTips.init();

  Ext.data.DataProxy.addListener('exception', function(proxy, type, action, options, response, arg) {
    if (type == 'response'){
      mxl_showErrorByResponseText(response.responseText, ""); 
    } else {      Ext.Msg.show({ 
        title: 'Ошибка',
        msg: print_r(response),
        icon: Ext.MessageBox.ERROR,
        buttons: Ext.Msg.OK
      });
    }
  });
}


Ext.util.Format.comboRenderer = function(combo) {
	return function(value) {
		var record = combo.findRecord(combo.valueField, value);
		return record ? record.get(combo.displayField) : combo.valueNotFoundText;
	}
}


function Get_SID() {
  var pageParameters = Ext.urlDecode(window.location.search.substring(1));
  return pageParameters["sid"];
}
