<?php
include_once realpath(dirname(__FILE__) . '\src\init.php');

$WGS = new mxl_widget_widgets();

$DBG1 = new mxl_widget_dbgrid('refpeoples1', 'refpeoples', new mxl_core_params(
    array('showFlat' => '1')));
//$DBG1->setEventHandler(mxl_widget_dbgrid::$ehtRefreshData, 'myHand');
$WGS->addWidget($DBG1);

$DBG = new mxl_widget_dbgrid('refcont_in_groups1', 'refcont_in_groups', new mxl_core_params(
    array('people_id' => -1)), false);
$DBG->setEventHandler(mxl_widget_dbgrid::$ehtAppendRow, 'refcont_in_groups1_onRowAdd');
$WGS->addWidget($DBG);

$fileName = realpath(dirname(__FILE__) . '\js_cash') . '\ref_peoples.js';
$WGS->WriteJScript($fileName);
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<title>Справочник Люди</title>
<link rel="stylesheet" type="text/css" href="./libs/extjs/resources/css/ext-all.css">
<link rel="stylesheet" href="./libs/extjs/plugins/Ext.ux.grid.GridSummary.css"/>

<script type="text/javascript" src="./libs/extjs/adapter/ext/ext-base.js"></script>
<script type="text/javascript" src="./libs/extjs/ext-all-debug.js"></script>
<script type="text/javascript" src="./libs/extjs/plugins/Ext.ux.grid.GridSummary.js"></script>
<script type="text/javascript" src="./libs/extjs/plugins/ux/CheckColumn.js"></script>

<script type="text/javascript" src="./src/js/metaxlib.js"></script>

<script type="text/javascript" src="./js_cash/ref_peoples.js"></script>

<script type="text/javascript">
    //Ext.BLANK_IMAGE_URL = './libs/extjs/resources/images/default/s.gif';
    //Ext.isSecure = true;
    function myupdateField() {
        //получаем строку грида как тип Record
        var gr_arr = dbg_refpeoples1.getSelectionModel().getSelected();
        form_contact.getForm().updateRecord(gr_arr);
    }

    //при выборе строки переносим данные в форму
    function selectGridRow() {
        var gr_arr = dbg_refpeoples1.getSelectionModel().getSelected();
        form_contact.getForm().loadRecord(gr_arr);

        //alert(gr_arr.data["people_id"]);
        if (gr_arr.data["people_id"]) {
            mxl_SetDynamicBaseParam(dbg_refcont_in_groups1.store, "people_id", gr_arr.data["people_id"]);
            dbg_refcont_in_groups1.store.load();
        } else {
            dbg_refcont_in_groups1.store.removeAll();
            form_contact.getForm().reset();
        }

    }
	
	function showFlat() {
		mxl_SetDynamicBaseParam(dbg_refpeoples1.store, "showFlat", '1');
        dbg_refpeoples1.store.reload();
	}

    //добавим форму для редактирования полей справочника контактов
    var form_contact = new Ext.form.FormPanel({
        title:'Редактирование записи',
        labelAlign:'left',
        labelWidth:80,
        frame:true,
        layout:'form',
        width:360, autoHeight:true,
        style:{padding:'10px'}

    });
    //ФИО контакта
    var contact_name = new Ext.form.TextField({
        fieldLabel:'Ф.И.О.',
        name:'fio',
        width:250
    });

    //дата рождения контакта
    var contact_birthday = new Ext.form.DateField({
        fieldLabel:'Дата рождения',
        name:'birthday',
        width:90,
        allowBlank:true,
        format:'d.m.Y h-m'
    });

    //комбо выбора города
    var cbxCity = new Ext.form.ComboBox({
        store:store_dbgcbx_dbg_refpeoples1_city,
        valueField:"city_id",
        displayField:"city_name",
        name:'city',
        valueNotFoundText:'-',
        fieldLabel:'Город',
        width:230,
        mode:"local",
        typeAhead:true,
        editable:true,
        minChars:0,
        forceSelection:false,
        selectOnFocus:false,
        listWidth:230,
        triggerAction:"all",
        emptyText:"Выберите город...",
        lazyRender:true

    });

    //комбо выбора улицы
    var cbxStreet = new Ext.form.ComboBox({
        store:store_dbgcbx_dbg_refpeoples1_street,
        valueField:"street_id",
        displayField:"street_name",
        name:'street',
        valueNotFoundText:'-',
        fieldLabel:'Улица',
        width:230,
        mode:"local",
        typeAhead:true,
        editable:true,
        minChars:0,
        forceSelection:false,
        selectOnFocus:false,
        listWidth:230,
        triggerAction:"all",
        emptyText:"Выберите улицу...",
        lazyRender:true

    });

    //дом
    var contact_house = new Ext.form.TextField({
        fieldLabel:'Дом',
        name:'home',
        width:50,
        vtype:'alphanum'
    });
    //корпус
    var contact_corp = new Ext.form.TextField({
        fieldLabel:'Корпус',
        name:'corp',
        width:50,
        vtype:'alphanum'
    });
    //квартира
    var contact_flat = new Ext.form.TextField({
        fieldLabel:'Квартира',
        name:'flat',
        width:50,
        vtype:'alphanum'
    });

    //кнопка
    var setButton = new Ext.Button({
        text:'Установить',
        handler:myupdateField,
        style:{marginLeft:'250px'}
    });

    function myHand() {
        alert('button');
    }

    //собираем форму в кучу
    var mCol = new Ext.util.MixedCollection();
    mCol.addAll([contact_name, contact_birthday, cbxCity, cbxStreet, contact_house, contact_corp, contact_flat, setButton]);

    //собственный обработчик добавления строки, на который ссылается инициализация грида
    function refcont_in_groups1_onRowAdd(event, toolEl, panel) {
        //добавляем строку в таблицу групп контакта refcont_in_groups1
        var newRecord = new record_refcont_in_groups1({});
        var sel = panel.getSelectionModel().getSelected();
        var selIndex = 1;
        if (sel)
            selIndex += panel.getStore().indexOf(sel)
        else
            selIndex = panel.getStore().getCount();
        panel.getStore().insert(selIndex, newRecord);
        panel.getSelectionModel().selectRow(selIndex);
        panel.getView().focusRow(selIndex);

        //теперь, после добавления, заменяем значение поля people_id на значение с people_id c таблицы людей
        var people_id = dbg_refpeoples1.getSelectionModel().getSelected().data["people_id"];
        if (people_id) {
            var gr_arr = dbg_refcont_in_groups1.getSelectionModel().getSelected();
            gr_arr.set('people_id', people_id);
            //чтобы не сохранять только введнный ID сбросим флаг модифицированности со строки
            gr_arr.commit();
        }
    }

    Ext.onReady(function () {
        startAutoGenScript();
        //добавляем обработчик событий грида при выборе строки, чтобы
        //переносить данные в форму для обработки
        dbg_refpeoples1.getSelectionModel().on('rowselect', selectGridRow);
        //после загрузки данных выбираем первую строку
        store_dbg_refpeoples1.addListener('datachanged', function () {
            dbg_refpeoples1.getSelectionModel().selectFirstRow()
        });
        //делаем рендер форме
        form_contact.items = mCol;
        //form_contact.items = dbg_refpeoples1.items;
        form_contact.render('pole');
    });
</script>
</head>
<body>
<?php include '/inc/top_head.php'; ?>
<br><br>
<table>
    <tbody>
    <tr>
        <td>
            <div id="pole" style="padding-left:50px">
        </td>
        <td>
            </div>
            <div id="dbg_refcont_in_groups1" style="padding-left:50px"></div>
        </td>
    </tr>
    </tbody>
</table>
<div id="dbg_refpeoples1" style="padding-left:50px"></div>
<a href="#" onclick="showFlat()">Показать квартиры</a>


</body>
</html>