function print_r(arr, level) {
    var print_red_text = "";
    if(!level) level = 0;
    var level_padding = "";
    for(var j=0; j<level+1; j++) level_padding += "    ";
    if(typeof(arr) == 'object') {
        for(var item in arr) {
            var value = arr[item];
            if(typeof(value) == 'object') {
                print_red_text += level_padding + "'" + item + "' :\n";
                print_red_text += print_r(value,level+1);
		} 
            else 
                print_red_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
        }
    } 

    else  print_red_text = "===>"+arr+"<===("+typeof(arr)+")";
    return print_red_text;
}

Ext.form.ClearableComboBox = Ext.extend(Ext.form.ComboBox, {
  initComponent: function() {
    this.triggerConfig = {
      tag:'span', cls:'x-form-twin-triggers', cn:[
        {tag: "img", src: Ext.BLANK_IMAGE_URL, cls: "x-form-trigger"},
        {tag: "img", src: Ext.BLANK_IMAGE_URL, cls: "x-form-trigger x-form-clear-trigger"}
    ]};
    Ext.form.ClearableComboBox.superclass.initComponent.call(this);
  },
  onTrigger2Click : function() {
    this.collapse();
    this.reset();                  // clear contents of combobox
    this.fireEvent('cleared'); // send notification that contents have been cleared
  },
  getTrigger: Ext.form.TwinTriggerField.prototype.getTrigger,
  initTrigger: Ext.form.TwinTriggerField.prototype.initTrigger,
  onTrigger1Click: Ext.form.ComboBox.prototype.onTriggerClick,
  trigger1Class: Ext.form.ComboBox.prototype.triggerClass
});

Ext.ux.grid.CheckColumnMxl = Ext.extend(Ext.ux.grid.CheckColumn, {
  onMouseDown : function(e, t){
    if(Ext.fly(t).hasClass(this.createId())){
      if (!this.readonly){
        e.stopEvent();
        var index = this.grid.getView().findRowIndex(t);
        var record = this.grid.store.getAt(index);
        record.set(this.dataIndex, !record.data[this.dataIndex]);
      }
    }
  }
});

Ext.util.Format.comboRenderer = function(combo) {
	return function(value) {
		var record = combo.findRecord(combo.valueField, value);
		return record ? record.get(combo.displayField) : combo.valueNotFoundText;
	}
}

function mxl_SetDynamicBaseParam(obj, param, value) {
  var baseparams = obj.baseParams["params"];
  var encodedBP = Ext.util.JSON.decode(baseparams);
  encodedBP[param] = value;
  obj.baseParams["params"] = Ext.util.JSON.encode(encodedBP);
}

function mxl_GetDynamicBaseParam(obj, param) {
 var baseparams = obj.baseParams["params"];
 var encodedBP = Ext.util.JSON.decode(baseparams);
 return encodedBP[param];
}

function mxl_cancelTimeShift_asMilliseconds(date_field, time_field){
  var str_date = date_field.value + ' ' + time_field.getValue();
  var mls_date = Date.parse(str_date + ' GMT' + mxl_wgs_server_time_zone);
  mls_date = mls_date - (3600000 * mxl_wgs_time_shift);
  return mls_date;
}

function mxl_cancelTimeShift_asMillisecondsDT(date_value){
  date_value = date_value - (3600000 * mxl_wgs_time_shift);
  return date_value;
}

function mxl_cancelTimeShift_asSeconds(date_field, time_field){
  var mls_date = mxl_cancelTimeShift_asMilliseconds(date_field, time_field);
  mls_date = Math.round(mls_date / 1000);
  return mls_date;
}

function mxl_cancelTimeShift_asSecondsDT(date_value){
  date_value = mxl_cancelTimeShift_asMillisecondsDT(date_value);
  date_value = Math.round(date_value / 1000);
  return date_value;
}

function mxl_cancelTimeShift_asDate(date_field, time_field){
  var mls_date = mxl_cancelTimeShift_asMilliseconds(date_field, time_field);
  var res_date = new Date(mls_date);
  return res_date;
}

function mxl_check_and_load_grid_store(store, fireevent){
  var allLoaded = true;
  if (store.need_loaded_elements){
    var nlc = store.need_loaded_elements;
    //for(var i = 0; i<= nlc.length(); i++){
    for(var i in nlc){
      
      if ((i !== undefined)&&(i != 'remove')){
        if ((!nlc[i])){
          allLoaded = false;
        }
      }
    }
  }
  if (allLoaded){
    if (fireevent){
      store.fireEvent('on_all_elements_loaded');
    } else {
      store.load();
    }
    store.allready_first_load = true;
  }
}
