<?php
/**
 * Файл для описания класса работы с URL, 
 * {@link mxl_cfg_url}.
 * @package mxl_cfg
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
/**
 * Класс для работы с URL
 * 
 * @package mxl_cfg
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_cfg_url{
	/**
	 * URL-адрес библиотеки
	 * @var string
	 */
	public static $metaxlib;
	
	/**
	 * Разделитель URL
	 * @var string
	 */
	public static $separator;
	
	/**
	 * Если указан то на него переводятся все запросы от библиотеки!
	 * @var string 
	 */
	public static $controller;
	
	/**
	 * Функция читает параметры класса из ассоциированного массива,
	 * сформированного на базе файла конфигурации
	 * @param array $cfg
	 */
	public static function readJSON($cfg){
		mxl_cfg_url::$separator = $cfg['url']['separator'];
		if (isset($cfg['url']['controller']))
			mxl_cfg_url::$controller = $cfg['url']['controller']; 
	}
}
?>