<?php
if (!defined('IN_SYS')){
	exit;
}

global $sys_root_path, $phpEx;

if (!defined('NL')) {
	define('NL', "\n");
}

class mxl_widget_extjswrapper{ 
	public static function Init_ExtJS($debug = 0, $postfix = '') {
		if (defined('SMARTY') && SMARTY){
			global $smarty;
			$smarty->assign('EXTJS_ENABLED', 	1);
			$smarty->assign('EXTJS_START_LINKS', mxl_widget_extjswrapper::getEXTJS_Start_Links($debug, $postfix));
		} else {
			global $template;
			$template->assign_vars(array(
				'EXTJS_ENABLED'		=> 1,
				'EXTJS_START_LINKS'	=> mxl_widget_extjswrapper::getEXTJS_Start_Links($debug, $postfix),
			));
		}
	}
	
	public static function getEXTJS_Start_Links($debug = 0, $postfix = '') {
		global $sys_root_path;
	
		$deb = $debug ? '-debug' : '';

		$x  = '<link href="'.$sys_root_path.'libs/extjs/resources/css/ext-all.css" rel="stylesheet" type= "text/css" media="screen" />'.NL;
		$x .= '<link href="'.$sys_root_path.'libs/extjs/plugins/Ext.ux.grid.GridSummary.css" rel="stylesheet"/>';
		$x .= '<script type="text/javascript" src="'.$sys_root_path.'libs/extjs/adapter/ext/ext-base.js"></script>'.NL;
    	$x .= '<script type="text/javascript" src="'.$sys_root_path.'libs/extjs/ext-all'.$postfix.$deb.'.js"></script>'.NL;
    	$x .= '<script type="text/javascript" src="'.$sys_root_path.'libs/extjs/plugins/Ext.ux.grid.GridSummary.js"></script>'.NL;
    	$x .= '<script type="text/javascript" src="'.$sys_root_path.'libs/extjs/plugins/ux/CheckColumn.js"></script>'.NL;
    	$x .= '<script type="text/javascript" src="'.$sys_root_path.'libs/MetaXLib/src/js/metaxlib.js"></script>'.NL;
    	
		$x .= '<link href="'.$sys_root_path.'libs/extjs/plugins/ux/css/MultiSelect.css" rel="stylesheet"/>';
    	$x .= '<script type="text/javascript" src="'.$sys_root_path.'libs/extjs/plugins/ux/MultiSelect.js"></script>'.NL;
    	$x .= '<script type="text/javascript" src="'.$sys_root_path.'libs/extjs/plugins/ux/ItemSelector.js"></script>'.NL;

    	$x .= 
    		'<script type="text/javascript">'.NL.
    		'	Ext.BLANK_IMAGE_URL = "'.$sys_root_path.'libs/extjs/resources/images/default/s.gif"'.NL.
    		'	Ext.isSecure = true;'.NL.
    		'</script>'.NL;
    
		return $x;	
	}
}
?>